hkm/urls.py
# -*- coding: utf-8 -*-

from django.conf.urls import url
from django.contrib.auth.decorators import login_required

from hkm.views import views
from hkm.decorators import restrict_for_museum
from hkm.views.checkout import OrderContactFormView, OrderSummaryView, OrderPBWNotify, OrderConfirmation

urlpatterns = [
    url(r'^$', views.HomeView.as_view(), name='hkm_home'),
    url(r'^info/$', views.InfoView.as_view(), name='hkm_info'),

    url(r'^about/$', views.SiteinfoAboutView.as_view(), name='hkm_siteinfo_about'),
    url(r'^accessibility/$', views.SiteinfoAccessibilityView.as_view(), name='hkm_siteinfo_accessibility'),
    url(r'^privacy/$', views.SiteinfoPrivacyView.as_view(),
        name='hkm_siteinfo_privacy'),
    url(r'^QA/$', views.SiteinfoQAView.as_view(), name='hkm_siteinfo_QA'),
    url(r'^terms/$', views.SiteinfoTermsView.as_view(), name='hkm_siteinfo_terms'),

    url(r'^collection/public/$', views.PublicCollectionsView.as_view(),
        name='hkm_public_collections'),
    url(r'^collection/my/$', restrict_for_museum(login_required()
        (views.MyCollectionsView.as_view())), name='hkm_my_collections'),
    url(r'^collection/(?P<collection_id>\d+)/$',
        views.CollectionDetailView.as_view(), name='hkm_collection'),

    url(r'^search/$', views.SearchView.as_view(), name='hkm_search'),
    url(r'^search/details/$', views.SearchRecordDetailView.as_view(),
        name='hkm_search_record'),
    url(r'^record/feedback/$', views.RecordFeedbackView.as_view(), name='hkm_record_feedback'),
    url(r'^record/(?P<finna_id>[a-zA-Z0-9:.]+)/$', views.LegacyRecordDetailView.as_view(),
        name='hkm_legacy_record_details'),

    url(r'^signup/$', restrict_for_museum(views.SignUpView.as_view()), name='hkm_signup'),
    url(r'^language/$', views.LanguageView.as_view(), name='hkm_language'),

    url(r'^order/contact/$', restrict_for_museum(OrderContactFormView.as_view()), name='hkm_order_contact'),
    url(r'^order/summary/$', restrict_for_museum(OrderSummaryView.as_view()), name='hkm_order_summary'),

    url(r'^order/(?P<finna_id>[a-zA-Z0-9:.]+)/$',
        views.CreateOrderView.as_view(), name='hkm_order_create'),
    url(r'^order/(?P<order_id>[a-zA-Z0-9]+)/product/$',
        views.OrderProductView.as_view(), name='hkm_order_product'),
    url(r'^order/(?P<order_id>[a-zA-Z0-9]+)/confirmation/$',
        restrict_for_museum(OrderConfirmation.as_view()), name='hkm_order_confirmation'),
    url(r'^order/(?P<order_id>[a-zA-Z0-9]+)/notify/$',
        restrict_for_museum(OrderPBWNotify.as_view()), name='hkm_order_pbw_notify'),
    url(r'^ajax/record/fav/$', restrict_for_museum(login_required()(views.AjaxUserFavoriteRecordView.as_view())),
        name='hkm_ajax_record_fav'),
    url(r'^ajax/crop/$', views.AjaxCropRecordView.as_view(),
        name='hkm_ajax_crop'),
    url(r'^ajax/collection/$', views.AjaxAddToCollection.as_view(),
        name='hkm_add_to_collection'),
    url(r'^basket/$', views.BasketView.as_view(), name='basket'),
    url(r'^basket/checkout/$', views.BasketView.as_view(), {"phase": "checkout"}, name='checkout'),
]

kuvaselaamo/urls.py
# -*- coding: utf-8 -*-

from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib import admin
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from django.http import HttpResponse


class AdminSite(admin.AdminSite):
    def has_permission(self, request):
        return request.user.is_active and request.user.is_staff and request.user.is_superuser


admin.site = AdminSite()
admin.autodiscover()

handler404 = 'hkm.views.views.handler404'
handler500 = 'hkm.views.views.handler500'

admin_urls = [
    url(r'^sysadmin/', include(admin.site.urls)),
]

app_urls = [
    url(r'^', include('hkm.urls')),
]

auth_urls = [
    url(r'^', include('django.contrib.auth.urls')),
]

static_urls = static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
static_urls += staticfiles_urlpatterns()

urlpatterns = admin_urls + app_urls + static_urls + auth_urls

if settings.DEBUG:
    from django.views.generic import TemplateView

    class ServerError(TemplateView):
        template_name = '500.html'

    class PageNotFoundError(TemplateView):
        template_name = '404.html'

    urlpatterns += [
        url(r'^500/$', ServerError.as_view()),
        url(r'^404/$', PageNotFoundError.as_view()),
    ]


#
# Kubernetes liveness & readiness probes
#
def healthz(*args, **kwargs):
    return HttpResponse(status=200)


def readiness(*args, **kwargs):
    return HttpResponse(status=200)


urlpatterns += [
    url(r'^healthz', healthz),
    url(r'^readiness', readiness)
]

hkm/models/campaigns.py
# -*- coding: utf-8 -*-
from decimal import Decimal

from django.db import models
from django.utils.translation import ugettext_lazy as _

from parler.managers import TranslatableQuerySet
from parler.models import TranslatableModel, TranslatedFields

import datetime
import random

CAMPAIGN_CODE_KEYSPACE = "acdefghkmnpqrstvwx123456789"


class CampaignUsageType(object):
    SINGLE_USE = "SINGLE_USE"
    CODELESS = "CODELESS"

    choices = (
        (SINGLE_USE, (u"Kertakäyttöinen")),
        (CODELESS, (u"Kooditon")),
    )


class CodeUsage(object):
    SINGLE_USE = "SINGLE_USE"
    MULTI_USE = "MULTI_USE"

    choices = (
        (SINGLE_USE, (u"Kertakäyttöinen")),
        (MULTI_USE, (u"Monikäyttöinen"))
    )


class CampaignStatus(object):
    DISABLED = "DISABLED"
    ENABLED = "ENABLED"

    choices = (
        (DISABLED, (u"Ei käytössä")),
        (ENABLED, (u"Aktiivinen"))
    )


class CampaignUserGroup(object):
    ALL = "ALL"
    MUSEUM = "MUSEUM"
    NORMAL = "NORMAL"

    choices = (
        (ALL, (u"Kaikki")),
        (MUSEUM, (u"Kioskikäyttäjät")),
        (NORMAL, (u"Normaalikäyttäjät"))
    )


class _UsageMixin(object):
    def is_applicable_in(self, dt):
        if not self.usable_from or dt >= self.usable_from:
            if not self.usable_to or dt <= self.usable_to:
                return True
        return False

    def is_applicable_today(self):
        return self.is_applicable_in(datetime.datetime.now().date())

    def is_used(self, user=None):
        if user and self.usage_type == CampaignUsageType.SINGLE_USE_PER_USER:
            if user.is_anonymous():  # No way to know whether it's used or not
                return False
            return self.campaign_usage.filter(order__user=user).exists()
        # because this mixin is inherited by Campaign AND Code check that SINGLE_USE applies only for Codes
        elif self.usage_type == CampaignUsageType.SINGLE_USE and not issubclass(type(self), Campaign):
            return self.campaign_usage.exists()
        else:
            return False


class CampaignQuerySet(TranslatableQuerySet):
    def for_user_group(self, is_museum_user=False):
        if is_museum_user:
            return self.filter(user_group__in=[CampaignUserGroup.MUSEUM, CampaignUserGroup.ALL])
        else:
            return self.filter(user_group__in=[CampaignUserGroup.NORMAL, CampaignUserGroup.ALL])


class Campaign(TranslatableModel, _UsageMixin):
    identifier = models.CharField(
        max_length=64,
        null=True,
        blank=True,
        db_index=True
    )
    status = models.CharField(
        default=CampaignStatus.ENABLED,
        verbose_name=_(u"Tila"),
        db_index=True,
        max_length=20,
        choices=CampaignStatus.choices
    )
    created_on = models.DateTimeField(auto_now_add=True)
    modified_on = models.DateTimeField(auto_now_add=True)

    usable_from = models.DateField(
        null=True,
        blank=True,
        verbose_name=_(u'Alkupäivämäärä')
    )
    usable_to = models.DateField(
        null=True,
        blank=True,
        verbose_name=_(u'Loppupäivämäärä')
    )
    usage_type = models.CharField(
        default=CampaignUsageType.SINGLE_USE,
        max_length=20,
        verbose_name=_(u"Tyyppi"),
        choices=CampaignUsageType.choices
    )
    user_group = models.CharField(
        default=CampaignUserGroup.ALL,
        verbose_name=_(u"Käyttäjäryhmä"),
        max_length=20,
        choices=CampaignUserGroup.choices,
        help_text=u"Käyttäjäryhmä, jolle tarjous on voimassa"
    )
    module = models.CharField(
        max_length=128,
        blank=True,
        verbose_name=_(u"Kampanjamoduuli")
    )
    mutex_group = models.CharField(
        max_length=32,
        blank=True,
        verbose_name=_(u"Yhteiskäyttöestoryhmä"),
        help_text=u"Mikäli asetettu, useampaa saman ryhmän kampanjaa ei voi käyttää yhdessä tilauksessa"
    )

    percentage_discount = models.DecimalField(
        decimal_places=2,
        verbose_name=_(u"Prosentuaalinen alennus"),
        max_digits=10,
        null=True,
        blank=True,
    )
    fixed_discount = models.DecimalField(
        decimal_places=2,
        verbose_name=_(u"Absoluuttinen alennus (veroton)"),
        max_digits=10,
        null=True,
        blank=True,
    )
    free_shipping = models.BooleanField(default=False, verbose_name=_(u'Free shipping'))
    translations = TranslatedFields(
        name=models.CharField(
            max_length=256,
            blank=True,
            verbose_name=_(u"Nimi")
        )
    )

    objects = CampaignQuerySet.as_manager()

    class Meta:
        verbose_name = _(u"kampanja")
        verbose_name_plural = _(u"kampanjat")

    def __unicode__(self):
        try:
            return unicode(self.name)
        except:
            return "%s %s" % (unicode(self._meta.verbose_name), self.pk)

    def get_discount_value(self, basket_lines):
        total_price = sum(l.total_price for l in basket_lines if l.type != 4)
        p_discount = 0
        f_discount = 0
        if self.percentage_discount:
            p_discount = (self.percentage_discount / 100) * total_price
        if self.fixed_discount:
            f_discount = self.fixed_discount

        return Decimal(max(p_discount, f_discount) * -1)


class CampaignCode(models.Model, _UsageMixin):
    campaign = models.ForeignKey(Campaign, related_name="campaign_codes", verbose_name=(u"Kampanja"))
    code = models.CharField(max_length=40, db_index=True)
    created_on = models.DateTimeField(auto_now_add=True)
    use_type = models.CharField(
        max_length=20,
        default=CodeUsage.SINGLE_USE,
        verbose_name=_(u"Käyttö"),
        db_index=True,
        choices=CodeUsage.choices
    )
    status = models.CharField(
        max_length=20,
        default=CampaignStatus.ENABLED,
        verbose_name=_(u"Tila"),
        db_index=True,
        choices=CampaignStatus.choices
    )

    class Meta:
        verbose_name = _(u"kampanjakoodi")
        verbose_name_plural = _(u"kampanjakoodit")

    def generate_code(self, length=10, prefix="", unique=True):
        while True:
            self.code = prefix + "".join(
                random.choice(CAMPAIGN_CODE_KEYSPACE) for x in xrange(length)
            ).upper()
            if unique and CampaignCode.objects.filter(code=self.code).exists():
                continue
            break

    def save(self, *args, **kwargs):
        if not self.code:
            self.generate_code()
        return super(CampaignCode, self).save(*args, **kwargs)

    def __unicode__(self):
        return self.code

hkm/forms.py
# -*- coding: utf-8 -*-

import logging

from django import forms
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from django.utils.translation import ugettext_lazy as _
from django.core.exceptions import ValidationError

from hkm.models.campaigns import CampaignCode
from hkm.models.models import Collection, Feedback, ProductOrder, ProductOrderCollection, Showcase

LOG = logging.getLogger(__name__)


class CollectionForm(forms.ModelForm):
    def __init__(self, *args, **kwargs):
        self.user = kwargs.pop('user')
        super(CollectionForm, self).__init__(*args, **kwargs)
        if not self.user.is_authenticated() or not self.user.profile.is_admin:
            del self.fields['show_in_landing_page']
            del self.fields['is_featured']

    class Meta:
        model = Collection
        fields = ['title', 'description', 'is_public',
                  'show_in_landing_page', 'is_featured']


class FeedbackForm(forms.ModelForm):
    def __init__(self, *args, **kwargs):
        self.user = kwargs.pop('user', None)
        return super(FeedbackForm, self).__init__(*args, **kwargs)

    def save(self, *args, **kwargs):
        commit = kwargs.get('commit', True)
        kwargs['commit'] = False
        feedback = super(FeedbackForm, self).save(*args, **kwargs)
        feedback.user = self.user
        if commit:
            feedback.save()
        return feedback

    class Meta:
        model = Feedback
        fields = ['content', 'full_name', 'email']


class OrderProductForm(forms.ModelForm):
    class Meta:
        model = ProductOrder
        fields = ['amount']


class OrderContactInformationForm(forms.ModelForm):
    class Meta:
        model = ProductOrder
        fields = ['first_name', 'last_name', 'email',
                  'phone', 'street_address', 'postal_code', 'city']


class RegistrationForm(UserCreationForm):
    def __init__(self, *args, **kwargs):
        super(RegistrationForm, self).__init__(*args, **kwargs)

        self.fields['email'].required = True

    class Meta:
        model = User
        fields = ['username', 'email']


class ProductOrderCollectionForm(forms.ModelForm):
    action = forms.CharField(widget=forms.HiddenInput(attrs={'value': 'checkout'}))
    orderer_name = forms.CharField(required=False, widget=forms.TextInput(attrs={'class': 'form-control'}),
                                   label=_(u"Orderer's name"))

    class Meta:
        model = ProductOrderCollection
        fields = ['orderer_name']


class GenerateCampaignCodesActionForm(forms.Form):
    code_prefix = forms.CharField(
        required=False,
        widget=forms.TextInput,
    )
    code_length = forms.CharField(
        required=False,
        widget=forms.TextInput,
    )
    amount = forms.IntegerField(
        required=False,
    )

    def form_action(self, campaign):
        for i in range(0, self.cleaned_data["amount"]):
            code = CampaignCode(campaign=campaign)
            code.generate_code(
                length=self.cleaned_data["code_length"],
                prefix=self.cleaned_data["code_prefix"],
            )
            code.save()

    # def save(self, campaign):
    #     try:
    #         account, action = self.form_action(account, user)
    #     except errors.Error as e:
    #         error_message = str(e)
    #         self.add_error(None, error_message)
    #         raise
    #
    #     return account, action


class ShowcaseForm(forms.ModelForm):
    class Meta:
        model = Showcase
        fields = ['title', 'albums', 'show_on_home_page']

    def clean(self):
        albums = self.cleaned_data.get('albums')

        if albums:
            if albums.count() > 3:
                raise ValidationError(_(u'Max amount of albums is three'))
        return self.cleaned_data

hkm/templates/hkm/views/_basket_content.html
{% load i18n l10n hkm_tags %}
{% for line in basket.product_lines %}
<div class="basket-row" data-lineId="{{ line.line_id }}">
    <a class="btn-delete-row" href="#" aria-label="{% trans 'Remove row' %}"><span></span></a>

    <div class="basket-thumbnail">
        <figure class="basket-thumbnail_figure">
            <img src="{{ line.order.image_url }}" alt="">
            <figcaption>{{ line.product.get_name_display }}</figcaption>
        </figure>
    </div>

    <h3 class="basket-title">{{ line.text }}</h3>

    <div class="basket-quantity">
        <a class="btn-down" href="#" data-toggle="tooltip" data-placement="top" aria-label="{% trans 'Decrease' %}">
            <svg class="svg-icon">
                <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#icon-angle"></use>
            </svg>
        </a>
        <h3 class="basket-quantity_value">{{ line.quantity }}</h3>
        <a class="btn-up" href="#" data-toggle="tooltip" data-placement="top" aria-label="{% trans 'Increase' %}">
            <svg class="svg-icon">
                <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#icon-angle"></use>
            </svg>
        </a>
        <h3 class="basket-quantity-value">{% trans "kpl" %}</h3>
    </div>

    <div class="basket-price">
        <span>{{ line.total_price|localized_decimal:2 }} €</span>
    </div>

</div>
{% endfor %}
{% for discount in basket.discount_lines %}
    {% include 'hkm/views/_discount_lines.html' with line=discount %}
{% endfor %}
    <input type="hidden" name="action" value="discount">
    <div class="basket-footer-row">
        <div class="basket-footer-input-wrapper">
            <label for="discount-code">{% trans "Discount code" %}:&nbsp;</label>
            <input id="discount-code" name="discount_code" type="text">
        </div>
        <button class="btn btn-primary btn-lg pull-right basket-footer-button add-discount">{% trans 'Use code' %}</button>
    </div>

hkm/templates/hkm/views/_discount_lines.html
{% load i18n l10n hkm_tags %}
<div class="basket-discount-row" data-campaignId="{{ line.campaign_id }}">
    {% if line.can_remove %}
        <a class="btn-delete-row" href="#" alt="Remove row"><span></span></a>
    {% endif %}
    <div class="discount-metadata">
        <h3>{{ line.text }} {% if line.code %} - {{ line.code }}{% endif %}</h3>
    </div>

    <div class="discount-price">
        <span class="basket-price-value">{{ line.total_price|localized_decimal:2 }} € </span>
    </div>

</div>

hkm/templates/hkm/views/collection_record.html
{% extends 'hkm/base_viewer.html' %}
{% load hkm_tags %}
{% load i18n %}

{% block viewer_arrows %}

  {% if previous_record %}
    <a href="{% url 'hkm_collection' collection_id=collection.id %}?rid={{ previous_record.id }}" class="image-viewer-arrow arrow-left"><img alt="{% trans 'Previous image' %}" src="/static/hkm/img/arrow_left.png"></img></a>
  {% endif %}
  {% if next_record %}
    <a href="{% url 'hkm_collection' collection_id=collection.id %}?rid={{ next_record.id }}" class="image-viewer-arrow arrow-right"><img alt="{% trans 'Next image' %}" src="/static/hkm/img/arrow_right.png"></img></a>
  {% endif %}

{% endblock %}

{% block content %}

  <div class="back-to">
    <span class="back-to__title">{{ record.title }}</span><br>
    <span>{% trans 'Collection' %}: {{ collection.title }} ({% trans 'Picture' %} {{ current_record_order_number }}/{{ collection_record_count }})</span><br>
    <a href="{% url 'hkm_collection' collection_id=collection.id %}">
      <i class="back-to__icon">
        <svg class="svg-icon">
          <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#icon-arrow-left"></use>
        </svg>
      </i>
      <span class="back-to__text">{% trans 'Back to collection' %}</span>
    </a>
  </div>

  <div title="{% trans 'Left and right click to zoom.' %}" class="image-viewer">
    <div id="zoomable-image-container" class="image-viewer__container">
      <img id="zoomable-image" class="image-viewer__image" data-full-res-url="{{ collection_record.get_full_res_image_absolute_url }}" src="{{ collection_record.get_preview_image_absolute_url }}"></img>
    </div>
  </div>
{% endblock %}

{% block hidden %}
  {% include 'hkm/snippets/popover_cart.html' with full_res_image_url=collection_record.get_full_res_image_absolute_url web_image_url=collection_record.record_id|finna_default_image_url cropped_web_image_url=collection_record.get_preview_image_absolute_url finna_id=collection_record.record_id %}
{% endblock %}

hkm/templates/hkm/views/info.html
{% extends 'hkm/base_browse.html' %}
{% load i18n %}

{% block banner %}

  <div class="page-header">
    <div class="fullsize-container container">
      <div class="banner__title">
        <h1 class="banner__h1 centered-fullwidth">{% trans 'Feedback' %}</h1>
      </div>
    </div>
  </div>

{% endblock %}

{% block content %}

  <div class="container-small container">

    <form id="feedback-form" method="POST">
      {% csrf_token %}
      {% include 'hkm/snippets/form_fields.html' with form=feedback_form %}
      <input type="hidden" name="action" value="feedback" />
      <p class="feedback-message success hidden" id="fb-success">{% trans 'Feedback success' %}</p>
      <p class="feedback-message error hidden" id="fb-error">{% trans 'Feedback error' %}</p>
      <button class="hkm-btn hkm-btn--default btn btn-primary" type="submit">{% trans 'Submit' %}</button>
    </form>

  </div>

{% endblock %}

hkm/templates/hkm/views/order.html
{% extends 'hkm/base_browse.html' %}
{% load i18n hkm_tags %}

{% block banner %}

{% endblock %}

{% block content %}

  <div class="fullsize-container">

    
    {% if order and record %}

      
      <div class="record-meta__col record-meta__col--left col-md-5">
        <h1 class="order-preview__title">{% trans 'Kuvan tilaaminen' %}</h1>
        <h2 class="order-meta__title-small">{{ record.title }}</h2>
        {% if not user.profile.is_museum %}
          <div class="order-steps-banner">
              {% include 'hkm/views/order_steps_menu.html' %}
          </div>
        {% endif %}
        <p class="order-meta__paragraph">{% trans 'Valitse alta haluamasi painotuotetyyppi ja tilattavien tuotteiden lukumäärä.' %} {% trans 'Rajaa kuva haluamasi suuruiseksi muuttamalla kuvan päällä oleva kehikon kokoa.' %}</p>
        <p class="order-meta__paragraph">{% trans 'Huomaathan, että rajaamalla kuvan kokoa laatu voi kärsiä.' %} {% trans 'Palvelu ilmoittaa, mikäli kuvanlaatu on alle suositellun rajan.' %}</p>
        <form method="POST">
          {% csrf_token %}
          <label for="product" class="control-label">{% trans 'Tuotetyyppi' %} *</label>
          <div class="row order-options">
          {% for product in product_types %}
            <div class="well well-sm col-xs-6 col-sm-4">
            <input type="radio" class="ordertype" name="product" {% if forloop.first and not order.product_type %} checked {% elif product.id == order.product_type_id %} checked {% endif %} value="{{ product.id }}" data-price="{{ product.price }}" data-xsize="{{ product.width }}" data-ysize="{{ product.height }}"> <span class="order-product__name">{% trans product.get_name_display %} ({{product.price}}€)</span>
            </div>
          {% endfor %}
          </div>
          {% include 'hkm/snippets/form_fields.html' with form=order_product_form %}
          
          <input type="hidden" name="crop_x" value="{{ order.crop_x }}" />
          <input type="hidden" name="crop_y" value="{{ order.crop_y }}" />
          <input type="hidden" name="crop_width" value="{{ order.crop_width }}" />
          <input type="hidden" name="crop_height" value="{{ order.crop_height }}" />
          <input type="hidden" name="original_width" value="{{ order.original_width }}" />
          <input type="hidden" name="original_height" value="{{ order.original_height }}" />

          <input type="hidden" name="action" value="order-product" />
          <div class="alert alert-success" id="ppi-box" role="alert">{% trans 'Valmiin tulosteen laatu:' %} <span data-full-x="{{ order.fullimg_original_width}}" data-full-y="{{ order.fullimg_original_height}}" id="ppi-indicator" data-language={{language}}>x</span></div>
          <p> {% trans 'Hinta yht.' %} <span id="price-indicator">
          {% if order.total_price %}
            {{ order.total_price }}
          {% else %}
            {% for product in product_types %}
              {% if forloop.first %}
                {{ product.price }}
              {% endif %}
            {% endfor %}
          {% endif %}
          </span> € {% if not user.profile.is_museum %}+ {% trans 'Shipping fees' %} {{ order.postal_fees }} €{% endif %} {% trans 'Incl. VAT' %}</p>

            <button class="hkm-btn hkm-btn--default btn btn-primary" value="add-to-basket" type="submit">{% trans 'Add to cart' %}</button>
        </form>
      </div>

      <div class="record-meta__col record-meta__col--right col-md-7">
        <div><img id="order-preview__image" data-img-url="{% finna_image order.record_finna_id %}" src="{% finna_image order.record_finna_id %}"></img></div>
      </div>
     
  </div>

    {% else %}

      {% include 'hkm/snippets/not_responding.html' %}

    {% endif %}

  </div>

{% endblock %}

hkm/templates/hkm/views/order_summary.html
{% extends 'hkm/base_browse.html' %}
{% load i18n hkm_tags %}

{% block banner %}

{% endblock %}

{% block content %}

  <div class="fullsize-container">

    {% if order %}

      
      <div class="record-meta__col record-meta__col--left col-md-12">
        <h1 class="order-preview__text">{% trans 'Kuvan tilaaminen' %}</h1>
        <h1 class="order-meta__title-small">{{ record.title }}</h1>
        <div class="order-steps-banner">
            {% include 'hkm/views/order_steps_menu.html' %}
        </div>
        <p>{% trans 'Tarkistathan, että tiedot ovat oikein.' %} {% trans 'Tämän jälkeen painamalla Tilaa-nappia siirryt maksusivulle.' %}</p>
        <table class="table table-striped">
        <caption>{% trans 'Contact details' %} (<a href="{% url 'hkm_order_contact' %}">{% trans 'Change' %}</a>)</caption>
        <tr>
        <td>{% trans 'Name' %}: </td><td>{{ order.first_name }} {{ order.last_name }}</td>
        </tr>
        <tr>
        <td>{% trans 'Email' %}: </td><td>{{ order.email }}</td>
        </tr>
        <tr>
        <td>{% trans 'Phone number' %}: </td><td>{{ order.phone }}</td>
        </tr>
        <tr>
        <td>{% trans 'Address' %}: </td><td>{{ order.street_address }}, {{ order.postal_code }} {{ order.city }}</td>
        </tr>
        </table>

        <table class="table table-striped">
        <caption>{% trans 'Order (noun)' %} (<a href="{% url 'basket' %}">{% trans 'Change' %}</a>)</caption>
        <tr>
            <th>{% trans 'Product' %}</th>
        <th>{% trans 'Amount' %}</th>
        <th>{% trans 'Price' %}</th>
        </tr>
        {% for line in request.basket.lines %}
        <tr>
          {% if line.product %}
            <td>{{ line.product.get_name_display }}</td>
            {% else %}
            <td>{{ line.text }}</td>
            {% endif %}
          <td>{{ line.quantity }}</td>
          <td>{{ line.total_price|localized_decimal:2 }} €</td>
        </tr>
        {% endfor %}
        <tr>
            <td colspan="2">{% trans 'Total' %}: </td>
        <td>
          {{ request.basket.basket_total_price|localized_decimal:2 }} € +
            {% if not request.basket.is_free_shipping %}
              {% trans 'Shipping fees' %} {{ order.postal_fees|localized_decimal:2 }} €
            {% else %}
                <span class="no-postal-fee"> {% trans 'Shipping fees' %} {{ order.postal_fees|localized_decimal:2 }} €</span> 0 €
            {% endif %}
                = {{ request.basket.total_price_with_postal_fees|localized_decimal:2 }} {% trans 'Incl. VAT' %}
        </td>
        </tr>
        </table>
        <form method="POST">
          {% csrf_token %}
          <input type="hidden" name="action" value="order-submit" />
          <button class="hkm-btn hkm-btn--default btn btn-primary" type="submit">{% trans 'Order (verb)' %}</button>
        </form>
        <p>{% trans 'By pressing Order (verb) you will be redirected to the secure payment service.' %}</p>
        <img src="/static/hkm/img/payform_row_no_invoices.png" class="order-payform-banner" />
      </div>
  </div>

    {% else %}

      {% include 'hkm/snippets/not_responding.html' %}

    {% endif %}

  </div>

{% endblock %}